// coding: utf-8
/** Created by: Udo Schmal | https://www.gocher.me/ */
(function() {
  'use strict';
  // load stylesheet
  if (!document.getElementById('object-fit.css')) {
    var style = document.createElement("link");
    style.type = 'text/css';
    style.href = '/code/object-fit/object-fit.css';
    style.id = 'object-fit.css';
    style.rel = 'stylesheet';
    document.head.appendChild(style);
    style.addEventListener('load', fit);
  } else {
    fit();
  }
  /*if ('objectFit' in document.documentElement.style === false) {*/
    console.log('object-fit fix');
    function cover(el) {
      var width, height, src;
      if (el.tagName.toLowerCase() == 'img') {
        width = el.naturalWidth;
        height = el.naturalHeight;
        src = el.src;
      } else if (el.tagName.toLowerCase() == 'video') {
        width = el.videoWidth;
        height = el.videoHeight;
        var els = el.getElementByTagName('source');
        if (els && els.length > 0) {
          src = els[0].src;
        }
      }
      let bounding = el.parentNode.getBoundingClientRect();
      console.log('use object-fit.js for ' + src);
      if ((bounding.width / bounding.height) > (width / height)) {
        el.style.height = 'auto';
      } else {
        el.style.width = 'auto';
      }
    }
    function fit() {
      var els = document.querySelectorAll('.fit-cover'), len = els.length, i;
      for (i=0; i < len; i++) {
        if (els[i].tagName.toLowerCase() == 'img') {
          if (!els[i].complete || (els[i].natuaralWidth === 0)) {
            els[i].addEventListener("load", function (event) { cover(this); });
          } else {
            cover(els[i]);
          }
        } else if (!els[i].tagName.toLowerCase() == 'video') {
          if (els[i].videoWidth == 0) {
            els[i].addEventListener("loadedmetadata", function (event) { cover(this); });
          } else {
            cover(els[i]);
          }
        }
      }
    }
  /*} else {
      console.log('native object-fit');
    }*/
})();
